#include "blendmode.glsl"

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform  lowp vec4 color;
uniform  lowp vec4 color1;
uniform  lowp vec4 color2;

uniform int compositingMode;
uniform int alphaMode;
uniform ivec3 grainModes;
uniform bvec3 grainFormats;
uniform bool alphaLocked;
uniform bool wet;

varying  highp vec2 textureCoordinate;
varying  highp vec2 textureCoordinate1;
varying  highp vec2 textureCoordinate2;
varying  highp vec2 textureCoordinate3;

void main()
{
    lowp vec4 src = texture2D(inputImageTexture, textureCoordinate) * color;
    
    if (color1.r > 0.0)
    {
        lowp vec4 grainRGBA = texture2D(inputImageTexture1, textureCoordinate1);
        lowp float grain = grainFormats.r ? grainRGBA.r : grainRGBA.a;
        
        src = grainBlendMode(grainModes.r, src, grain, color1.r, color2.r);
    }
    
    if (color1.g > 0.0)
    {
        lowp vec4 grainRGBA = texture2D(inputImageTexture2, textureCoordinate2);
        lowp float grain = grainFormats.g ? grainRGBA.r : grainRGBA.a;
        
        src = grainBlendMode(grainModes.g, src, grain, color1.g, color2.g);
    }
    
    if (color1.b > 0.0)
    {
        lowp vec4 grainRGBA = texture2D(inputImageTexture3, textureCoordinate3);
        lowp float grain = grainFormats.b ? grainRGBA.r : grainRGBA.a;
        
        src = grainBlendMode(grainModes.b, src, grain, color1.b, color2.b);
    }
    
    gl_FragColor = src;
}
