uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
uniform sampler2D inputImageTexture2;

uniform  lowp vec4 color;

varying  highp vec2 textureCoordinate;
varying  highp vec2 textureCoordinate1;

void main()
{
     lowp vec4 dst = texture2D(inputImageTexture1, textureCoordinate1);
    if ( (textureCoordinate.s >= 0.0) && (textureCoordinate.s <= 1.0) && (textureCoordinate.t >= 0.0) && (textureCoordinate.t <= 1.0) )
    {
         lowp float alpha = floor(texture2D(inputImageTexture, textureCoordinate).a * color.a * 2048.0 + 0.5);
        
        if (alpha >= 1.0)
        {
             lowp float malpha = floor(2048.0 - alpha + 0.5);
            
             lowp vec4 src = texture2D(inputImageTexture2, textureCoordinate1);
            
            gl_FragColor = (alpha * src + malpha * dst) / 2048.0;
            
            const  lowp float threshold = 1.0 / 256.0;
            if (( abs(dst.r - src.r) <= threshold ) &&
                ( abs(dst.g - src.g) <= threshold ) &&
                ( abs(dst.b - src.b) <= threshold ) &&
                ( abs(dst.a - src.a) <= threshold ))
                gl_FragColor = dst;
        }
        else
        {
            gl_FragColor = dst;
        }
    }
    else
    {
        gl_FragColor = dst;
    }
}