uniform sampler2D inputImageTexture;
uniform  lowp vec4 color;

varying  highp vec2 textureCoordinate0;
varying  highp vec2 textureCoordinate1;
varying  highp vec2 textureCoordinate2;
varying  highp vec2 textureCoordinate3;
varying  highp vec2 textureCoordinate4;
varying  highp vec2 textureCoordinate5;
varying  highp vec2 textureCoordinate6;
varying  highp vec2 textureCoordinate7;
varying  highp vec2 textureCoordinate8;


 lowp float threshold( lowp float thr1,  lowp float thr2 ,  lowp float val)
{
    if (val < thr1)
        return 0.0;
    
    if (val > thr2)
        return 1.0;
    
    return (val - thr1) / (thr2 - thr1);
}

 lowp float avg_intensity( lowp vec4 pix)
{
    return (pix.r + pix.g + pix.b) * pix.a / 3.;
}

void main()
{
     lowp float edge = threshold(0.0,
                                0.3,
                                (  abs(avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate1))) - avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate7))))
                                 + abs(avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate5))) - avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate3))))
                                 + abs(avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate0))) - avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate8))))
                                 + abs(avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate2))) - avg_intensity(texture2D(inputImageTexture, vec2(textureCoordinate6))))
                                 ) / 4.0);
    
    gl_FragColor = color * vec4(edge, edge, edge, 1.0);
}