uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
uniform sampler2D inputImageTexture2;

uniform lowp vec4 color;
uniform lowp vec4 color1;
uniform lowp vec4 color2;

varying highp vec2 textureCoordinate;

void main()
{
    lowp vec4 src = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 dst = texture2D(inputImageTexture1, textureCoordinate);
    
    lowp float alpha = texture2D(inputImageTexture2, textureCoordinate).r;
    
    if (color2.r > 0.5)
    {
        lowp float srcAlpha = src.a;
        
        if (srcAlpha > 0.0)
            src = vec4((1.0 / srcAlpha) * src.rgb, 1.0);
        else
            src = vec4(0.0);
        
        if (color2.r > 2.5)
        {
            if ( (alpha > 0.0) && (((1.0 - srcAlpha) / alpha) < 1.0) )
                src = (1.0 - ((1.0 - srcAlpha) / alpha)) * src;
            else
                src = vec4(0.0);
        }
        else if (color2.r > 1.5)
        {
            if (srcAlpha < 0.5)
                src = 2.0 * alpha * srcAlpha * src * color;
            else
                src = (1.0 - 2.0 * (1.0 - alpha) * (1.0 - srcAlpha)) * src * color;
        }
        else
        {
            if ( (alpha < 0.5) || (srcAlpha < 0.5) )
                src = vec4(0.0);
            else
                src = src * color;
        }
    }
    else
    {
        src = alpha * src * color;
    }
    
    if (color2.a > 0.0)
    {
        if (color2.r > 0.5)
        {
            lowp float dstAlpha = dst.a;
            
            if (dstAlpha > 0.0)
                dst = vec4((1.0 / dstAlpha) * dst.rgb, 1.0);
            else
                dst = vec4(0.0);
            
            if (color2.r > 2.5)
            {
                if ( (alpha > 0.0) && (((1.0 - dstAlpha) / alpha) < 1.0) )
                    dst = (1.0 - ((1.0 - dstAlpha) / alpha)) * dst;
                else
                    dst = vec4(0.0);
            }
            else if (color2.r > 1.5)
            {
                if (dstAlpha < 0.5)
                    dst = 2.0 * alpha * dstAlpha * dst;
                else
                    dst = (1.0 - 2.0 * (1.0 - alpha) * (1.0 - dstAlpha)) * dst;
            }
            else
            {
                if ( (alpha < 0.5) || (dstAlpha < 0.5) )
                    dst = vec4(0.0);
            }
        }
        else
        {
            dst = alpha * dst;
        }
    }
    
    gl_FragColor = max(src, dst) * color1;
}