uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;

uniform  lowp vec4 color;
uniform  lowp vec4 color1;
// No mask color.
uniform  lowp vec4 color3;

varying  highp vec2 textureCoordinate;

void alphaLockedDraw(lowp vec4 src, lowp vec4 dst)
{
    lowp float alpha = dst.a;
    if (alpha > 0.0)
    {
        dst = vec4((1.0 / alpha) * dst.rgb, 1.0);
        src = (src + (vec4(1) - src) * dst) * color1;
        gl_FragColor = alpha * src;
    }
    else
    {
        gl_FragColor = vec4(0.0);
    }
}

void draw(lowp vec4 src, lowp vec4 dst)
{
    gl_FragColor = (src + (vec4(1) - src) * dst) * color1;
}

void main()
{
     lowp vec4 src = texture2D(inputImageTexture, textureCoordinate) * color;
     lowp vec4 dst = texture2D(inputImageTexture1, textureCoordinate);
    
    if (color3.a > 0.5)
        alphaLockedDraw(src, dst);
    else
        draw(src, dst);
}
