#include "blendmode.glsl"
#include "layers-blendmodes.glsl"

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
#ifdef auxiliaryLayerBlendMode
uniform sampler2D inputImageTexture2; // auxiliary layer
#endif

uniform  lowp vec4 color;
uniform  lowp vec4 color1;
uniform  lowp vec4 color2; // alpha modes
// No mask color.

uniform int compositingMode;
uniform int alphaMode;
uniform ivec3 grainModes;
uniform bvec3 grainFormats;
uniform bool alphaLocked;
uniform bool wet;

varying  highp vec2 textureCoordinate;
#ifdef auxiliaryLayerBlendMode
varying  highp vec2 textureCoordinate1;
#endif

void main()
{
    lowp vec4 src = texture2D(inputImageTexture, textureCoordinate) * color;
    
#ifdef auxiliaryLayerBlendMode
    lowp vec4 aux = texture2D(inputImageTexture2, textureCoordinate1);
    src = blendLayer(src, aux, auxiliaryLayerBlendMode, false);
#endif

    src = applyAlphaModeLevel(src, color2.g);
    
    lowp vec4 dst = texture2D(inputImageTexture1, textureCoordinate);

    gl_FragColor = blendLayer(src, dst, layerBlendMode, alphaLocked) * color1;
}
