uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;

uniform  lowp vec4 color;

varying  highp vec2 textureCoordinate;

void main()
{
     lowp float smudge = floor(color.a * 2048.0 + 0.5);
     lowp float msmudge = floor(2048.0 - smudge + 0.5);
    
     lowp vec4 src = texture2D(inputImageTexture, textureCoordinate);
     lowp vec4 dst = texture2D(inputImageTexture1, textureCoordinate);
    
    const  lowp float threshold = 1.0 / 256.0;
    if (( abs(dst.r - src.r) <= threshold ) &&
        ( abs(dst.g - src.g) <= threshold ) &&
        ( abs(dst.b - src.b) <= threshold ) &&
        ( abs(dst.a - src.a) <= threshold ))
        gl_FragColor = src;
    else
        gl_FragColor = (src * msmudge + dst * smudge) / 2048.0;
}