uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
uniform sampler2D inputImageTexture2; // mask texture

uniform  lowp vec4 color;
uniform  highp vec4 color1;
uniform  lowp vec4 color2; // mask color

varying  highp vec2 textureCoordinate;

highp float mod289(highp float x){return x - floor(x * (1.0 / 289.0)) * 289.0;}
highp vec4 mod289(highp vec4 x){return x - floor(x * (1.0 / 289.0)) * 289.0;}
highp vec4 perm(highp vec4 x){return mod289(((x * 34.0) + 1.0) * x);}

lowp float noise3(highp vec3 p){
    highp vec3 a = floor(p);
    lowp vec3 d = p - a;
    d = d * d * (3.0 - 2.0 * d);
    
    highp vec4 b = a.xxyy + vec4(0.0, 1.0, 0.0, 1.0);
    highp vec4 k1 = perm(b.xyxy);
    highp vec4 k2 = perm(k1.xyxy + b.zzww);
    
    highp vec4 c = k2 + a.zzzz;
    highp vec4 k3 = perm(c);
    highp vec4 k4 = perm(c + 1.0);
    
    highp vec4 o1 = fract(k3 * (1.0 / 41.0));
    highp vec4 o2 = fract(k4 * (1.0 / 41.0));
    
    highp vec4 o3 = o2 * d.z + o1 * (1.0 - d.z);
    highp vec2 o4 = o3.yw * d.x + o3.xz * (1.0 - d.x);
    
    return o4.y * d.y + o4.x * (1.0 - d.y);
}

lowp float rand(highp float n){return fract(sin(n) * 43758.5453123);}

lowp float noise(highp float p){
    highp float fl = floor(p);
    highp float fc = fract(p);
    return mix(rand(fl), rand(fl + 1.0), fc);
}

void main()
{
    lowp vec4 src = texture2D(inputImageTexture, textureCoordinate) * color;
    lowp vec4 dst = texture2D(inputImageTexture1, textureCoordinate);

    highp vec2 relPos = gl_FragCoord.xy - color1.xy;
    lowp vec2 dir = normalize(relPos);
    highp float distToCenter = length(relPos);
    highp float radius = color1.w * color1.z * (0.9 + 0.3 * noise3(vec3(atan(dir.y, dir.x) * 3.0, 0.0, color1.z * 16.0)));
    highp float alpha = 1.0 - smoothstep(radius - 5.0, radius + 5.0, distToCenter);
    
    gl_FragColor = mix(src, dst, alpha);
    //gl_FragColor = vec4(gl_FragCoord.xy / color1.w, 0, 1);
}
