uniform highp mat4 projection;
uniform highp mat4 modelView;
uniform highp vec4 color1;

attribute highp vec4 position;
attribute highp vec4 texCoord;

varying highp vec4 coordinates;
varying highp vec4 kernel0;
varying highp vec4 kernel1;
varying highp vec4 kernel2;
varying highp vec4 kernel3;
varying highp vec4 kernel4;
varying highp vec4 kernel5;
varying highp vec4 kernel6;

void main()
{
    gl_Position = (projection * modelView) * position;
    
    highp float step = color1.r;
    highp float sigma = color1.a;
    highp float sigma2 = 2.0 * sigma * sigma;
    
    kernel0 = vec4(1.0, exp( - 1.0 / sigma2 ), exp( - 4.0 / sigma2 ), exp( - 9.0 / sigma2 ));
    kernel1 = vec4(exp( - 16.0 / sigma2 ), exp( - 25.0 / sigma2 ), exp( - 36.0 / sigma2 ), exp( - 49.0 / sigma2 ));
    kernel2 = vec4(exp( - 64.0 / sigma2 ), exp( - 81.0 / sigma2 ), exp( - 100.0 / sigma2 ), exp( - 121.0 / sigma2 ));
    kernel3 = vec4(exp( - 144.0 / sigma2 ), exp( - 169.0 / sigma2 ), exp( - 196.0 / sigma2 ), exp( - 225.0 / sigma2 ));
    kernel4 = vec4(exp( - 256.0 / sigma2 ), exp( - 289.0 / sigma2 ), exp( - 324.0 / sigma2 ), exp( - 361.0 / sigma2 ));
    kernel5 = vec4(exp( - 400.0 / sigma2 ), exp( - 441.0 / sigma2 ), exp( - 484.0 / sigma2 ), exp( - 529.0 / sigma2 ));
    kernel6 = vec4(exp( - 576.0 / sigma2 ), exp( - 625.0 / sigma2 ), exp( - 676.0 / sigma2 ), exp( - 729.0 / sigma2 ));
    
    highp float sum = kernel0.x + 2.0 * (kernel0.y + kernel0.z + kernel0.w
                                         + kernel1.x + kernel1.y + kernel1.z + kernel1.w
                                         + kernel2.x + kernel2.y + kernel2.z + kernel2.w
                                         + kernel3.x + kernel3.y + kernel3.z + kernel3.w
                                         + kernel4.x + kernel4.y + kernel4.z + kernel4.w
                                         + kernel5.x + kernel5.y + kernel5.z + kernel5.w
                                         + kernel6.x + kernel6.y + kernel6.z + kernel6.w);
    
    kernel0 = kernel0 / sum;
    kernel1 = kernel1 / sum;
    kernel2 = kernel2 / sum;
    kernel3 = kernel3 / sum;
    kernel4 = kernel4 / sum;
    kernel5 = kernel5 / sum;
    kernel6 = kernel6 / sum;
    
    coordinates.st = texCoord.st;
    coordinates.pq = vec2(step, 0.0);
}
